import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class EntityDetectorConfiguration{EntityTypes:List<Value<string>>;AllowedStatistics?:AllowedStatistics;constructor(properties:EntityDetectorConfiguration);}export declare class ValidationConfiguration{RulesetArn:Value<string>;ValidationMode?:Value<string>;constructor(properties:ValidationConfiguration);}export declare class DataCatalogOutput{CatalogId?:Value<string>;DatabaseName:Value<string>;TableName:Value<string>;S3Options?:S3TableOutputOptions;DatabaseOptions?:DatabaseTableOutputOptions;Overwrite?:Value<boolean>;constructor(properties:DataCatalogOutput);}export declare class S3Location{Bucket:Value<string>;Key?:Value<string>;BucketOwner?:Value<string>;constructor(properties:S3Location);}export declare class OutputFormatOptions{Csv?:CsvOutputOptions;constructor(properties:OutputFormatOptions);}export declare class CsvOutputOptions{Delimiter?:Value<string>;constructor(properties:CsvOutputOptions);}export declare class Recipe{Name:Value<string>;Version?:Value<string>;constructor(properties:Recipe);}export declare class S3TableOutputOptions{Location:S3Location;constructor(properties:S3TableOutputOptions);}export declare class Output{CompressionFormat?:Value<string>;Format?:Value<string>;FormatOptions?:OutputFormatOptions;PartitionColumns?:List<Value<string>>;Location:S3Location;Overwrite?:Value<boolean>;MaxOutputFiles?:Value<number>;constructor(properties:Output);}export declare class OutputLocation{Bucket:Value<string>;Key?:Value<string>;BucketOwner?:Value<string>;constructor(properties:OutputLocation);}export declare class ColumnSelector{Regex?:Value<string>;Name?:Value<string>;constructor(properties:ColumnSelector);}export declare class StatisticsConfiguration{IncludedStatistics?:List<Value<string>>;Overrides?:List<StatisticOverride>;constructor(properties:StatisticsConfiguration);}export declare class DatabaseOutput{GlueConnectionName:Value<string>;DatabaseOutputMode?:Value<string>;DatabaseOptions:DatabaseTableOutputOptions;constructor(properties:DatabaseOutput);}export declare class AllowedStatistics{Statistics:List<Value<string>>;constructor(properties:AllowedStatistics);}export declare class DatabaseTableOutputOptions{TempDirectory?:S3Location;TableName:Value<string>;constructor(properties:DatabaseTableOutputOptions);}export declare type ParameterMap={[key:string]:any;};export declare class StatisticOverride{Statistic:Value<string>;Parameters:ParameterMap;constructor(properties:StatisticOverride);}export declare class JobSample{Mode?:Value<string>;Size?:Value<number>;constructor(properties:JobSample);}export declare class ColumnStatisticsConfiguration{Selectors?:List<ColumnSelector>;Statistics:StatisticsConfiguration;constructor(properties:ColumnStatisticsConfiguration);}export declare class ProfileConfiguration{DatasetStatisticsConfiguration?:StatisticsConfiguration;ProfileColumns?:List<ColumnSelector>;ColumnStatisticsConfigurations?:List<ColumnStatisticsConfiguration>;EntityDetectorConfiguration?:EntityDetectorConfiguration;constructor(properties:ProfileConfiguration);}export interface Properties{DatasetName?:Value<string>;EncryptionKeyArn?:Value<string>;EncryptionMode?:Value<string>;Name:Value<string>;Type:Value<string>;LogSubscription?:Value<string>;MaxCapacity?:Value<number>;MaxRetries?:Value<number>;Outputs?:List<Output>;DataCatalogOutputs?:List<DataCatalogOutput>;DatabaseOutputs?:List<DatabaseOutput>;OutputLocation?:OutputLocation;ProjectName?:Value<string>;Recipe?:Recipe;RoleArn:Value<string>;Tags?:List<ResourceTag>;Timeout?:Value<number>;JobSample?:JobSample;ProfileConfiguration?:ProfileConfiguration;ValidationConfigurations?:List<ValidationConfiguration>;}declare class Job extends ResourceBase<Properties>{static EntityDetectorConfiguration:typeof EntityDetectorConfiguration;static ValidationConfiguration:typeof ValidationConfiguration;static DataCatalogOutput:typeof DataCatalogOutput;static S3Location:typeof S3Location;static OutputFormatOptions:typeof OutputFormatOptions;static CsvOutputOptions:typeof CsvOutputOptions;static Recipe:typeof Recipe;static S3TableOutputOptions:typeof S3TableOutputOptions;static Output:typeof Output;static OutputLocation:typeof OutputLocation;static ColumnSelector:typeof ColumnSelector;static StatisticsConfiguration:typeof StatisticsConfiguration;static DatabaseOutput:typeof DatabaseOutput;static AllowedStatistics:typeof AllowedStatistics;static DatabaseTableOutputOptions:typeof DatabaseTableOutputOptions;static StatisticOverride:typeof StatisticOverride;static JobSample:typeof JobSample;static ColumnStatisticsConfiguration:typeof ColumnStatisticsConfiguration;static ProfileConfiguration:typeof ProfileConfiguration;constructor(properties:Properties);}export{Job as R};