import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class FleetLaunchTemplateSpecificationRequest{LaunchTemplateName?:Value<string>;LaunchTemplateId?:Value<string>;Version?:Value<string>;constructor(properties:FleetLaunchTemplateSpecificationRequest);}export declare class NetworkInterfaceCountRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:NetworkInterfaceCountRequest);}export declare class TargetCapacitySpecificationRequest{DefaultTargetCapacityType?:Value<string>;TargetCapacityUnitType?:Value<string>;TotalTargetCapacity:Value<number>;OnDemandTargetCapacity?:Value<number>;SpotTargetCapacity?:Value<number>;constructor(properties:TargetCapacitySpecificationRequest);}export declare class CapacityReservationOptionsRequest{UsageStrategy?:Value<string>;constructor(properties:CapacityReservationOptionsRequest);}export declare class BaselineEbsBandwidthMbpsRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:BaselineEbsBandwidthMbpsRequest);}export declare class TotalLocalStorageGBRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:TotalLocalStorageGBRequest);}export declare class FleetLaunchTemplateConfigRequest{LaunchTemplateSpecification?:FleetLaunchTemplateSpecificationRequest;Overrides?:List<FleetLaunchTemplateOverridesRequest>;constructor(properties:FleetLaunchTemplateConfigRequest);}export declare class TagSpecification{ResourceType?:Value<string>;Tags?:List<ResourceTag>;constructor(properties:TagSpecification);}export declare class SpotOptionsRequest{MaintenanceStrategies?:MaintenanceStrategies;SingleAvailabilityZone?:Value<boolean>;AllocationStrategy?:Value<string>;SingleInstanceType?:Value<boolean>;MinTargetCapacity?:Value<number>;MaxTotalPrice?:Value<string>;InstanceInterruptionBehavior?:Value<string>;InstancePoolsToUseCount?:Value<number>;constructor(properties:SpotOptionsRequest);}export declare class InstanceRequirementsRequest{VCpuCount?:VCpuCountRangeRequest;MemoryMiB?:MemoryMiBRequest;CpuManufacturers?:List<Value<string>>;MemoryGiBPerVCpu?:MemoryGiBPerVCpuRequest;ExcludedInstanceTypes?:List<Value<string>>;InstanceGenerations?:List<Value<string>>;SpotMaxPricePercentageOverLowestPrice?:Value<number>;OnDemandMaxPricePercentageOverLowestPrice?:Value<number>;BareMetal?:Value<string>;BurstablePerformance?:Value<string>;RequireHibernateSupport?:Value<boolean>;NetworkInterfaceCount?:NetworkInterfaceCountRequest;LocalStorage?:Value<string>;LocalStorageTypes?:List<Value<string>>;TotalLocalStorageGB?:TotalLocalStorageGBRequest;BaselineEbsBandwidthMbps?:BaselineEbsBandwidthMbpsRequest;AcceleratorTypes?:List<Value<string>>;AcceleratorCount?:AcceleratorCountRequest;AcceleratorManufacturers?:List<Value<string>>;AcceleratorNames?:List<Value<string>>;AcceleratorTotalMemoryMiB?:AcceleratorTotalMemoryMiBRequest;constructor(properties:InstanceRequirementsRequest);}export declare class AcceleratorTotalMemoryMiBRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:AcceleratorTotalMemoryMiBRequest);}export declare class MemoryGiBPerVCpuRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:MemoryGiBPerVCpuRequest);}export declare class OnDemandOptionsRequest{SingleAvailabilityZone?:Value<boolean>;AllocationStrategy?:Value<string>;SingleInstanceType?:Value<boolean>;MinTargetCapacity?:Value<number>;MaxTotalPrice?:Value<string>;CapacityReservationOptions?:CapacityReservationOptionsRequest;constructor(properties:OnDemandOptionsRequest);}export declare class FleetLaunchTemplateOverridesRequest{WeightedCapacity?:Value<number>;Placement?:Placement;Priority?:Value<number>;AvailabilityZone?:Value<string>;SubnetId?:Value<string>;InstanceType?:Value<string>;InstanceRequirements?:InstanceRequirementsRequest;MaxPrice?:Value<string>;constructor(properties:FleetLaunchTemplateOverridesRequest);}export declare class Placement{GroupName?:Value<string>;Tenancy?:Value<string>;SpreadDomain?:Value<string>;PartitionNumber?:Value<number>;AvailabilityZone?:Value<string>;Affinity?:Value<string>;HostId?:Value<string>;HostResourceGroupArn?:Value<string>;constructor(properties:Placement);}export declare class MemoryMiBRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:MemoryMiBRequest);}export declare class CapacityRebalance{ReplacementStrategy?:Value<string>;TerminationDelay?:Value<number>;constructor(properties:CapacityRebalance);}export declare class MaintenanceStrategies{CapacityRebalance?:CapacityRebalance;constructor(properties:MaintenanceStrategies);}export declare class VCpuCountRangeRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:VCpuCountRangeRequest);}export declare class AcceleratorCountRequest{Min?:Value<number>;Max?:Value<number>;constructor(properties:AcceleratorCountRequest);}export interface Properties{TargetCapacitySpecification:TargetCapacitySpecificationRequest;OnDemandOptions?:OnDemandOptionsRequest;Type?:Value<string>;ExcessCapacityTerminationPolicy?:Value<string>;TagSpecifications?:List<TagSpecification>;SpotOptions?:SpotOptionsRequest;ValidFrom?:Value<string>;ReplaceUnhealthyInstances?:Value<boolean>;LaunchTemplateConfigs:List<FleetLaunchTemplateConfigRequest>;TerminateInstancesWithExpiration?:Value<boolean>;ValidUntil?:Value<string>;Context?:Value<string>;}declare class EC2Fleet extends ResourceBase<Properties>{static FleetLaunchTemplateSpecificationRequest:typeof FleetLaunchTemplateSpecificationRequest;static NetworkInterfaceCountRequest:typeof NetworkInterfaceCountRequest;static TargetCapacitySpecificationRequest:typeof TargetCapacitySpecificationRequest;static CapacityReservationOptionsRequest:typeof CapacityReservationOptionsRequest;static BaselineEbsBandwidthMbpsRequest:typeof BaselineEbsBandwidthMbpsRequest;static TotalLocalStorageGBRequest:typeof TotalLocalStorageGBRequest;static FleetLaunchTemplateConfigRequest:typeof FleetLaunchTemplateConfigRequest;static TagSpecification:typeof TagSpecification;static SpotOptionsRequest:typeof SpotOptionsRequest;static InstanceRequirementsRequest:typeof InstanceRequirementsRequest;static AcceleratorTotalMemoryMiBRequest:typeof AcceleratorTotalMemoryMiBRequest;static MemoryGiBPerVCpuRequest:typeof MemoryGiBPerVCpuRequest;static OnDemandOptionsRequest:typeof OnDemandOptionsRequest;static FleetLaunchTemplateOverridesRequest:typeof FleetLaunchTemplateOverridesRequest;static Placement:typeof Placement;static MemoryMiBRequest:typeof MemoryMiBRequest;static CapacityRebalance:typeof CapacityRebalance;static MaintenanceStrategies:typeof MaintenanceStrategies;static VCpuCountRangeRequest:typeof VCpuCountRangeRequest;static AcceleratorCountRequest:typeof AcceleratorCountRequest;constructor(properties:Properties);}export{EC2Fleet as R};