import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class DatasetContentVersionValue{DatasetName:Value<string>;constructor(properties:DatasetContentVersionValue);}export declare class GlueConfiguration{DatabaseName:Value<string>;TableName:Value<string>;constructor(properties:GlueConfiguration);}export declare class DeltaTimeSessionWindowConfiguration{TimeoutInMinutes:Value<number>;constructor(properties:DeltaTimeSessionWindowConfiguration);}export declare class OutputFileUriValue{FileName:Value<string>;constructor(properties:OutputFileUriValue);}export declare class Filter{DeltaTime?:DeltaTime;constructor(properties:Filter);}export declare class DatasetContentDeliveryRule{Destination:DatasetContentDeliveryRuleDestination;EntryName?:Value<string>;constructor(properties:DatasetContentDeliveryRule);}export declare class Action{ActionName:Value<string>;ContainerAction?:ContainerAction;QueryAction?:QueryAction;constructor(properties:Action);}export declare class LateDataRuleConfiguration{DeltaTimeSessionWindowConfiguration?:DeltaTimeSessionWindowConfiguration;constructor(properties:LateDataRuleConfiguration);}export declare class ContainerAction{Variables?:List<Variable>;ExecutionRoleArn:Value<string>;Image:Value<string>;ResourceConfiguration:ResourceConfiguration;constructor(properties:ContainerAction);}export declare class LateDataRule{RuleConfiguration:LateDataRuleConfiguration;RuleName?:Value<string>;constructor(properties:LateDataRule);}export declare class QueryAction{Filters?:List<Filter>;SqlQuery:Value<string>;constructor(properties:QueryAction);}export declare class DatasetContentDeliveryRuleDestination{IotEventsDestinationConfiguration?:IotEventsDestinationConfiguration;S3DestinationConfiguration?:S3DestinationConfiguration;constructor(properties:DatasetContentDeliveryRuleDestination);}export declare class VersioningConfiguration{Unlimited?:Value<boolean>;MaxVersions?:Value<number>;constructor(properties:VersioningConfiguration);}export declare class Schedule{ScheduleExpression:Value<string>;constructor(properties:Schedule);}export declare class RetentionPeriod{NumberOfDays?:Value<number>;Unlimited?:Value<boolean>;constructor(properties:RetentionPeriod);}export declare class S3DestinationConfiguration{GlueConfiguration?:GlueConfiguration;Bucket:Value<string>;Key:Value<string>;RoleArn:Value<string>;constructor(properties:S3DestinationConfiguration);}export declare class Variable{VariableName:Value<string>;DatasetContentVersionValue?:DatasetContentVersionValue;StringValue?:Value<string>;DoubleValue?:Value<number>;OutputFileUriValue?:OutputFileUriValue;constructor(properties:Variable);}export declare class DeltaTime{OffsetSeconds:Value<number>;TimeExpression:Value<string>;constructor(properties:DeltaTime);}export declare class Trigger{TriggeringDataset?:TriggeringDataset;Schedule?:Schedule;constructor(properties:Trigger);}export declare class IotEventsDestinationConfiguration{InputName:Value<string>;RoleArn:Value<string>;constructor(properties:IotEventsDestinationConfiguration);}export declare class ResourceConfiguration{VolumeSizeInGB:Value<number>;ComputeType:Value<string>;constructor(properties:ResourceConfiguration);}export declare class TriggeringDataset{DatasetName:Value<string>;constructor(properties:TriggeringDataset);}export interface Properties{Actions:List<Action>;LateDataRules?:List<LateDataRule>;DatasetName?:Value<string>;ContentDeliveryRules?:List<DatasetContentDeliveryRule>;Triggers?:List<Trigger>;VersioningConfiguration?:VersioningConfiguration;RetentionPeriod?:RetentionPeriod;Tags?:List<ResourceTag>;}declare class Dataset extends ResourceBase<Properties>{static DatasetContentVersionValue:typeof DatasetContentVersionValue;static GlueConfiguration:typeof GlueConfiguration;static DeltaTimeSessionWindowConfiguration:typeof DeltaTimeSessionWindowConfiguration;static OutputFileUriValue:typeof OutputFileUriValue;static Filter:typeof Filter;static DatasetContentDeliveryRule:typeof DatasetContentDeliveryRule;static Action:typeof Action;static LateDataRuleConfiguration:typeof LateDataRuleConfiguration;static ContainerAction:typeof ContainerAction;static LateDataRule:typeof LateDataRule;static QueryAction:typeof QueryAction;static DatasetContentDeliveryRuleDestination:typeof DatasetContentDeliveryRuleDestination;static VersioningConfiguration:typeof VersioningConfiguration;static Schedule:typeof Schedule;static RetentionPeriod:typeof RetentionPeriod;static S3DestinationConfiguration:typeof S3DestinationConfiguration;static Variable:typeof Variable;static DeltaTime:typeof DeltaTime;static Trigger:typeof Trigger;static IotEventsDestinationConfiguration:typeof IotEventsDestinationConfiguration;static ResourceConfiguration:typeof ResourceConfiguration;static TriggeringDataset:typeof TriggeringDataset;constructor(properties:Properties);}export{Dataset as R};