import{ResourceBase}from'../resource';import{Value,List}from'../dataTypes';export declare class DataLocationResource{CatalogId:Value<string>;ResourceArn:Value<string>;constructor(properties:DataLocationResource);}export declare class LFTagKeyResource{CatalogId:Value<string>;TagKey:Value<string>;TagValues:List<Value<string>>;constructor(properties:LFTagKeyResource);}export declare type CatalogResource={[key:string]:any;};export declare class TableResource{CatalogId:Value<string>;DatabaseName:Value<string>;Name?:Value<string>;TableWildcard?:TableWildcard;constructor(properties:TableResource);}export declare type TableWildcard={[key:string]:any;};export declare class ColumnWildcard{ExcludedColumnNames?:List<Value<string>>;constructor(properties:ColumnWildcard);}export declare class DatabaseResource{CatalogId:Value<string>;Name:Value<string>;constructor(properties:DatabaseResource);}export declare class TableWithColumnsResource{CatalogId:Value<string>;DatabaseName:Value<string>;Name:Value<string>;ColumnNames?:List<Value<string>>;ColumnWildcard?:ColumnWildcard;constructor(properties:TableWithColumnsResource);}export declare class Resource{Catalog?:CatalogResource;Database?:DatabaseResource;Table?:TableResource;TableWithColumns?:TableWithColumnsResource;DataLocation?:DataLocationResource;DataCellsFilter?:DataCellsFilterResource;LFTag?:LFTagKeyResource;LFTagPolicy?:LFTagPolicyResource;constructor(properties:Resource);}export declare class DataLakePrincipal{DataLakePrincipalIdentifier?:Value<string>;constructor(properties:DataLakePrincipal);}export declare class LFTag{TagKey?:Value<string>;TagValues?:List<Value<string>>;constructor(properties:LFTag);}export declare class LFTagPolicyResource{CatalogId:Value<string>;ResourceType:Value<string>;Expression:List<LFTag>;constructor(properties:LFTagPolicyResource);}export declare class DataCellsFilterResource{TableCatalogId:Value<string>;DatabaseName:Value<string>;TableName:Value<string>;Name:Value<string>;constructor(properties:DataCellsFilterResource);}export interface Properties{Catalog?:Value<string>;Principal:DataLakePrincipal;Resource:Resource;Permissions:List<Value<string>>;PermissionsWithGrantOption:List<Value<string>>;}declare class PrincipalPermissions extends ResourceBase<Properties>{static DataLocationResource:typeof DataLocationResource;static LFTagKeyResource:typeof LFTagKeyResource;static TableResource:typeof TableResource;static ColumnWildcard:typeof ColumnWildcard;static DatabaseResource:typeof DatabaseResource;static TableWithColumnsResource:typeof TableWithColumnsResource;static Resource:typeof Resource;static DataLakePrincipal:typeof DataLakePrincipal;static LFTag:typeof LFTag;static LFTagPolicyResource:typeof LFTagPolicyResource;static DataCellsFilterResource:typeof DataCellsFilterResource;constructor(properties:Properties);}export{PrincipalPermissions as R};