import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class SlotValueRegexFilter{Pattern:Value<string>;constructor(properties:SlotValueRegexFilter);}export declare class FulfillmentUpdatesSpecification{StartResponse?:FulfillmentStartResponseSpecification;UpdateResponse?:FulfillmentUpdateResponseSpecification;TimeoutInSeconds?:Value<number>;Active:Value<boolean>;constructor(properties:FulfillmentUpdatesSpecification);}export declare class SlotType{Name:Value<string>;Description?:Value<string>;ParentSlotTypeSignature?:Value<string>;SlotTypeValues?:List<SlotTypeValue>;ValueSelectionSetting?:SlotValueSelectionSetting;ExternalSourceSetting?:ExternalSourceSetting;constructor(properties:SlotType);}export declare class CustomVocabularyItem{Phrase:Value<string>;Weight?:Value<number>;constructor(properties:CustomVocabularyItem);}export declare class InputContext{Name:Value<string>;constructor(properties:InputContext);}export declare class PromptSpecification{MessageGroupsList:List<MessageGroup>;MaxRetries:Value<number>;AllowInterrupt?:Value<boolean>;constructor(properties:PromptSpecification);}export declare class CustomVocabulary{CustomVocabularyItems:List<CustomVocabularyItem>;constructor(properties:CustomVocabulary);}export declare class VoiceSettings{VoiceId:Value<string>;constructor(properties:VoiceSettings);}export declare class AudioLogSetting{Destination:AudioLogDestination;Enabled:Value<boolean>;constructor(properties:AudioLogSetting);}export declare class IntentConfirmationSetting{PromptSpecification:PromptSpecification;DeclinationResponse:ResponseSpecification;IsActive?:Value<boolean>;constructor(properties:IntentConfirmationSetting);}export declare class Message{PlainTextMessage?:PlainTextMessage;CustomPayload?:CustomPayload;SSMLMessage?:SSMLMessage;ImageResponseCard?:ImageResponseCard;constructor(properties:Message);}export declare class CodeHookSpecification{LambdaCodeHook:LambdaCodeHook;constructor(properties:CodeHookSpecification);}export declare class WaitAndContinueSpecification{WaitingResponse:ResponseSpecification;ContinueResponse:ResponseSpecification;StillWaitingResponse?:StillWaitingResponseSpecification;IsActive?:Value<boolean>;constructor(properties:WaitAndContinueSpecification);}export declare class TestBotAliasSettings{BotAliasLocaleSettings?:List<BotAliasLocaleSettingsItem>;ConversationLogSettings?:ConversationLogSettings;Description?:Value<string>;SentimentAnalysisSettings?:{[key:string]:any;};constructor(properties:TestBotAliasSettings);}export declare class CloudWatchLogGroupLogDestination{CloudWatchLogGroupArn:Value<string>;LogPrefix:Value<string>;constructor(properties:CloudWatchLogGroupLogDestination);}export declare class SlotValueElicitationSetting{DefaultValueSpecification?:SlotDefaultValueSpecification;SlotConstraint:Value<string>;PromptSpecification?:PromptSpecification;SampleUtterances?:List<SampleUtterance>;WaitAndContinueSpecification?:WaitAndContinueSpecification;constructor(properties:SlotValueElicitationSetting);}export declare class BotAliasLocaleSettings{CodeHookSpecification?:CodeHookSpecification;Enabled:Value<boolean>;constructor(properties:BotAliasLocaleSettings);}export declare class MultipleValuesSetting{AllowMultipleValues?:Value<boolean>;constructor(properties:MultipleValuesSetting);}export declare class SlotDefaultValueSpecification{DefaultValueList:List<SlotDefaultValue>;constructor(properties:SlotDefaultValueSpecification);}export declare class ExternalSourceSetting{GrammarSlotTypeSetting?:GrammarSlotTypeSetting;constructor(properties:ExternalSourceSetting);}export declare class DialogCodeHookSetting{Enabled:Value<boolean>;constructor(properties:DialogCodeHookSetting);}export declare class ObfuscationSetting{ObfuscationSettingType:Value<string>;constructor(properties:ObfuscationSetting);}export declare class FulfillmentStartResponseSpecification{MessageGroups:List<MessageGroup>;DelayInSeconds:Value<number>;AllowInterrupt?:Value<boolean>;constructor(properties:FulfillmentStartResponseSpecification);}export declare class Intent{Name:Value<string>;Description?:Value<string>;ParentIntentSignature?:Value<string>;SampleUtterances?:List<SampleUtterance>;DialogCodeHook?:DialogCodeHookSetting;FulfillmentCodeHook?:FulfillmentCodeHookSetting;IntentConfirmationSetting?:IntentConfirmationSetting;IntentClosingSetting?:IntentClosingSetting;InputContexts?:List<InputContext>;OutputContexts?:List<OutputContext>;KendraConfiguration?:KendraConfiguration;SlotPriorities?:List<SlotPriority>;Slots?:List<Slot>;constructor(properties:Intent);}export declare class ResponseSpecification{MessageGroupsList:List<MessageGroup>;AllowInterrupt?:Value<boolean>;constructor(properties:ResponseSpecification);}export declare class BotLocale{LocaleId:Value<string>;Description?:Value<string>;VoiceSettings?:VoiceSettings;NluConfidenceThreshold:Value<number>;Intents?:List<Intent>;SlotTypes?:List<SlotType>;CustomVocabulary?:CustomVocabulary;constructor(properties:BotLocale);}export declare class TextLogDestination{CloudWatch:CloudWatchLogGroupLogDestination;constructor(properties:TextLogDestination);}export declare class S3Location{S3Bucket:Value<string>;S3ObjectKey:Value<string>;S3ObjectVersion?:Value<string>;constructor(properties:S3Location);}export declare class SlotDefaultValue{DefaultValue:Value<string>;constructor(properties:SlotDefaultValue);}export declare class SlotPriority{Priority:Value<number>;SlotName:Value<string>;constructor(properties:SlotPriority);}export declare class SlotValueSelectionSetting{ResolutionStrategy:Value<string>;RegexFilter?:SlotValueRegexFilter;AdvancedRecognitionSetting?:AdvancedRecognitionSetting;constructor(properties:SlotValueSelectionSetting);}export declare class AdvancedRecognitionSetting{AudioRecognitionStrategy?:Value<string>;constructor(properties:AdvancedRecognitionSetting);}export declare class ImageResponseCard{Title:Value<string>;Subtitle?:Value<string>;ImageUrl?:Value<string>;Buttons?:List<Button>;constructor(properties:ImageResponseCard);}export declare class SlotTypeValue{SampleValue:SampleValue;Synonyms?:List<SampleValue>;constructor(properties:SlotTypeValue);}export declare class Button{Text:Value<string>;Value:Value<string>;constructor(properties:Button);}export declare class PlainTextMessage{Value:Value<string>;constructor(properties:PlainTextMessage);}export declare class SSMLMessage{Value:Value<string>;constructor(properties:SSMLMessage);}export declare class KendraConfiguration{KendraIndex:Value<string>;QueryFilterStringEnabled?:Value<boolean>;QueryFilterString?:Value<string>;constructor(properties:KendraConfiguration);}export declare class GrammarSlotTypeSource{S3BucketName:Value<string>;S3ObjectKey:Value<string>;KmsKeyArn?:Value<string>;constructor(properties:GrammarSlotTypeSource);}export declare class MessageGroup{Message:Message;Variations?:List<Message>;constructor(properties:MessageGroup);}export declare class PostFulfillmentStatusSpecification{SuccessResponse?:ResponseSpecification;FailureResponse?:ResponseSpecification;TimeoutResponse?:ResponseSpecification;constructor(properties:PostFulfillmentStatusSpecification);}export declare class Slot{Name:Value<string>;Description?:Value<string>;SlotTypeName:Value<string>;ValueElicitationSetting:SlotValueElicitationSetting;ObfuscationSetting?:ObfuscationSetting;MultipleValuesSetting?:MultipleValuesSetting;constructor(properties:Slot);}export declare class SampleUtterance{Utterance:Value<string>;constructor(properties:SampleUtterance);}export declare class FulfillmentUpdateResponseSpecification{MessageGroups:List<MessageGroup>;FrequencyInSeconds:Value<number>;AllowInterrupt?:Value<boolean>;constructor(properties:FulfillmentUpdateResponseSpecification);}export declare class GrammarSlotTypeSetting{Source?:GrammarSlotTypeSource;constructor(properties:GrammarSlotTypeSetting);}export declare class BotAliasLocaleSettingsItem{LocaleId:Value<string>;BotAliasLocaleSetting:BotAliasLocaleSettings;constructor(properties:BotAliasLocaleSettingsItem);}export declare class IntentClosingSetting{ClosingResponse:ResponseSpecification;IsActive?:Value<boolean>;constructor(properties:IntentClosingSetting);}export declare class ConversationLogSettings{AudioLogSettings?:List<AudioLogSetting>;TextLogSettings?:List<TextLogSetting>;constructor(properties:ConversationLogSettings);}export declare class AudioLogDestination{S3Bucket:S3BucketLogDestination;constructor(properties:AudioLogDestination);}export declare class TextLogSetting{Destination:TextLogDestination;Enabled:Value<boolean>;constructor(properties:TextLogSetting);}export declare class StillWaitingResponseSpecification{MessageGroupsList:List<MessageGroup>;FrequencyInSeconds:Value<number>;TimeoutInSeconds:Value<number>;AllowInterrupt?:Value<boolean>;constructor(properties:StillWaitingResponseSpecification);}export declare class OutputContext{Name:Value<string>;TimeToLiveInSeconds:Value<number>;TurnsToLive:Value<number>;constructor(properties:OutputContext);}export declare class LambdaCodeHook{CodeHookInterfaceVersion:Value<string>;LambdaArn:Value<string>;constructor(properties:LambdaCodeHook);}export declare class S3BucketLogDestination{S3BucketArn:Value<string>;LogPrefix:Value<string>;KmsKeyArn?:Value<string>;constructor(properties:S3BucketLogDestination);}export declare class FulfillmentCodeHookSetting{FulfillmentUpdatesSpecification?:FulfillmentUpdatesSpecification;PostFulfillmentStatusSpecification?:PostFulfillmentStatusSpecification;Enabled:Value<boolean>;constructor(properties:FulfillmentCodeHookSetting);}export declare class CustomPayload{Value:Value<string>;constructor(properties:CustomPayload);}export declare class SampleValue{Value:Value<string>;constructor(properties:SampleValue);}export interface Properties{Name:Value<string>;Description?:Value<string>;RoleArn:Value<string>;DataPrivacy:{[key:string]:any;};IdleSessionTTLInSeconds:Value<number>;BotLocales?:List<BotLocale>;BotFileS3Location?:S3Location;BotTags?:List<ResourceTag>;TestBotAliasTags?:List<ResourceTag>;AutoBuildBotLocales?:Value<boolean>;TestBotAliasSettings?:TestBotAliasSettings;}declare class Bot extends ResourceBase<Properties>{static SlotValueRegexFilter:typeof SlotValueRegexFilter;static FulfillmentUpdatesSpecification:typeof FulfillmentUpdatesSpecification;static SlotType:typeof SlotType;static CustomVocabularyItem:typeof CustomVocabularyItem;static InputContext:typeof InputContext;static PromptSpecification:typeof PromptSpecification;static CustomVocabulary:typeof CustomVocabulary;static VoiceSettings:typeof VoiceSettings;static AudioLogSetting:typeof AudioLogSetting;static IntentConfirmationSetting:typeof IntentConfirmationSetting;static Message:typeof Message;static CodeHookSpecification:typeof CodeHookSpecification;static WaitAndContinueSpecification:typeof WaitAndContinueSpecification;static TestBotAliasSettings:typeof TestBotAliasSettings;static CloudWatchLogGroupLogDestination:typeof CloudWatchLogGroupLogDestination;static SlotValueElicitationSetting:typeof SlotValueElicitationSetting;static BotAliasLocaleSettings:typeof BotAliasLocaleSettings;static MultipleValuesSetting:typeof MultipleValuesSetting;static SlotDefaultValueSpecification:typeof SlotDefaultValueSpecification;static ExternalSourceSetting:typeof ExternalSourceSetting;static DialogCodeHookSetting:typeof DialogCodeHookSetting;static ObfuscationSetting:typeof ObfuscationSetting;static FulfillmentStartResponseSpecification:typeof FulfillmentStartResponseSpecification;static Intent:typeof Intent;static ResponseSpecification:typeof ResponseSpecification;static BotLocale:typeof BotLocale;static TextLogDestination:typeof TextLogDestination;static S3Location:typeof S3Location;static SlotDefaultValue:typeof SlotDefaultValue;static SlotPriority:typeof SlotPriority;static SlotValueSelectionSetting:typeof SlotValueSelectionSetting;static AdvancedRecognitionSetting:typeof AdvancedRecognitionSetting;static ImageResponseCard:typeof ImageResponseCard;static SlotTypeValue:typeof SlotTypeValue;static Button:typeof Button;static PlainTextMessage:typeof PlainTextMessage;static SSMLMessage:typeof SSMLMessage;static KendraConfiguration:typeof KendraConfiguration;static GrammarSlotTypeSource:typeof GrammarSlotTypeSource;static MessageGroup:typeof MessageGroup;static PostFulfillmentStatusSpecification:typeof PostFulfillmentStatusSpecification;static Slot:typeof Slot;static SampleUtterance:typeof SampleUtterance;static FulfillmentUpdateResponseSpecification:typeof FulfillmentUpdateResponseSpecification;static GrammarSlotTypeSetting:typeof GrammarSlotTypeSetting;static BotAliasLocaleSettingsItem:typeof BotAliasLocaleSettingsItem;static IntentClosingSetting:typeof IntentClosingSetting;static ConversationLogSettings:typeof ConversationLogSettings;static AudioLogDestination:typeof AudioLogDestination;static TextLogSetting:typeof TextLogSetting;static StillWaitingResponseSpecification:typeof StillWaitingResponseSpecification;static OutputContext:typeof OutputContext;static LambdaCodeHook:typeof LambdaCodeHook;static S3BucketLogDestination:typeof S3BucketLogDestination;static FulfillmentCodeHookSetting:typeof FulfillmentCodeHookSetting;static CustomPayload:typeof CustomPayload;static SampleValue:typeof SampleValue;constructor(properties:Properties);}export{Bot as R};