import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class Explainability{Report?:MetricsSource;constructor(properties:Explainability);}export declare class ValidationSpecification{ValidationProfiles:List<ValidationProfile>;ValidationRole:Value<string>;constructor(properties:ValidationSpecification);}export declare class TransformJobDefinition{Environment?:Environment;BatchStrategy?:Value<string>;MaxConcurrentTransforms?:Value<number>;MaxPayloadInMB?:Value<number>;TransformInput:TransformInput;TransformOutput:TransformOutput;TransformResources:TransformResources;constructor(properties:TransformJobDefinition);}export declare class DriftCheckModelDataQuality{Constraints?:MetricsSource;Statistics?:MetricsSource;constructor(properties:DriftCheckModelDataQuality);}export declare class FileSource{ContentDigest?:Value<string>;ContentType?:Value<string>;S3Uri:Value<string>;constructor(properties:FileSource);}export declare class MetricsSource{ContentDigest?:Value<string>;ContentType:Value<string>;S3Uri:Value<string>;constructor(properties:MetricsSource);}export declare class ModelPackageStatusItem{FailureReason?:Value<string>;Name:Value<string>;Status:Value<string>;constructor(properties:ModelPackageStatusItem);}export declare class AdditionalInferenceSpecificationDefinition{Containers:List<ModelPackageContainerDefinition>;Description?:Value<string>;Name:Value<string>;SupportedContentTypes?:List<Value<string>>;SupportedRealtimeInferenceInstanceTypes?:List<Value<string>>;SupportedResponseMIMETypes?:List<Value<string>>;SupportedTransformInstanceTypes?:List<Value<string>>;constructor(properties:AdditionalInferenceSpecificationDefinition);}export declare class SourceAlgorithmSpecification{SourceAlgorithms:List<SourceAlgorithm>;constructor(properties:SourceAlgorithmSpecification);}export declare class ModelQuality{Constraints?:MetricsSource;Statistics?:MetricsSource;constructor(properties:ModelQuality);}export declare type Environment={[key:string]:any;};export declare class S3DataSource{S3DataType:Value<string>;S3Uri:Value<string>;constructor(properties:S3DataSource);}export declare class ModelMetrics{Bias?:Bias;Explainability?:Explainability;ModelDataQuality?:ModelDataQuality;ModelQuality?:ModelQuality;constructor(properties:ModelMetrics);}export declare class SourceAlgorithm{AlgorithmName:Value<string>;ModelDataUrl?:Value<string>;constructor(properties:SourceAlgorithm);}export declare class InferenceSpecification{Containers:List<ModelPackageContainerDefinition>;SupportedContentTypes:List<Value<string>>;SupportedRealtimeInferenceInstanceTypes?:List<Value<string>>;SupportedResponseMIMETypes:List<Value<string>>;SupportedTransformInstanceTypes?:List<Value<string>>;constructor(properties:InferenceSpecification);}export declare class MetadataProperties{CommitId?:Value<string>;GeneratedBy?:Value<string>;ProjectId?:Value<string>;Repository?:Value<string>;constructor(properties:MetadataProperties);}export declare class DriftCheckExplainability{Constraints?:MetricsSource;ConfigFile?:FileSource;constructor(properties:DriftCheckExplainability);}export declare class TransformResources{InstanceCount:Value<number>;InstanceType:Value<string>;VolumeKmsKeyId?:Value<string>;constructor(properties:TransformResources);}export declare class ModelPackageContainerDefinition{ContainerHostname?:Value<string>;Environment?:Environment;ModelInput?:{[key:string]:any;};Image:Value<string>;ImageDigest?:Value<string>;ModelDataUrl?:Value<string>;ProductId?:Value<string>;Framework?:Value<string>;FrameworkVersion?:Value<string>;NearestModelName?:Value<string>;constructor(properties:ModelPackageContainerDefinition);}export declare class ValidationProfile{TransformJobDefinition:TransformJobDefinition;ProfileName:Value<string>;constructor(properties:ValidationProfile);}export declare class Bias{Report?:MetricsSource;PreTrainingReport?:MetricsSource;PostTrainingReport?:MetricsSource;constructor(properties:Bias);}export declare class DriftCheckModelQuality{Constraints?:MetricsSource;Statistics?:MetricsSource;constructor(properties:DriftCheckModelQuality);}export declare class DataSource{S3DataSource:S3DataSource;constructor(properties:DataSource);}export declare class TransformOutput{Accept?:Value<string>;KmsKeyId?:Value<string>;S3OutputPath:Value<string>;AssembleWith?:Value<string>;constructor(properties:TransformOutput);}export declare class ModelPackageStatusDetails{ImageScanStatuses?:List<ModelPackageStatusItem>;ValidationStatuses:List<ModelPackageStatusItem>;constructor(properties:ModelPackageStatusDetails);}export declare class DriftCheckBaselines{Bias?:DriftCheckBias;Explainability?:DriftCheckExplainability;ModelDataQuality?:DriftCheckModelDataQuality;ModelQuality?:DriftCheckModelQuality;constructor(properties:DriftCheckBaselines);}export declare class ModelDataQuality{Constraints?:MetricsSource;Statistics?:MetricsSource;constructor(properties:ModelDataQuality);}export declare class TransformInput{CompressionType?:Value<string>;ContentType?:Value<string>;DataSource:DataSource;SplitType?:Value<string>;constructor(properties:TransformInput);}export declare class DriftCheckBias{PostTrainingConstraints?:MetricsSource;PreTrainingConstraints?:MetricsSource;ConfigFile?:FileSource;constructor(properties:DriftCheckBias);}export interface Properties{Tag?:ResourceTag;Tags?:List<ResourceTag>;AdditionalInferenceSpecifications?:List<AdditionalInferenceSpecificationDefinition>;AdditionalInferenceSpecificationDefinition?:AdditionalInferenceSpecificationDefinition;CertifyForMarketplace?:Value<boolean>;ClientToken?:Value<string>;CustomerMetadataProperties?:{[key:string]:Value<string>;};Domain?:Value<string>;DriftCheckBaselines?:DriftCheckBaselines;InferenceSpecification?:InferenceSpecification;MetadataProperties?:MetadataProperties;ModelApprovalStatus?:Value<string>;ModelMetrics?:ModelMetrics;ModelPackageDescription?:Value<string>;ModelPackageGroupName?:Value<string>;ModelPackageName?:Value<string>;SamplePayloadUrl?:Value<string>;SourceAlgorithmSpecification?:SourceAlgorithmSpecification;Task?:Value<string>;ValidationSpecification?:ValidationSpecification;ApprovalDescription?:Value<string>;LastModifiedTime?:Value<string>;ModelPackageVersion?:Value<number>;AdditionalInferenceSpecificationsToAdd?:List<AdditionalInferenceSpecificationDefinition>;ModelPackageStatusDetails?:ModelPackageStatusDetails;ModelPackageStatusItem?:ModelPackageStatusItem;Environment?:{[key:string]:Value<string>;};}declare class ModelPackage extends ResourceBase<Properties>{static Explainability:typeof Explainability;static ValidationSpecification:typeof ValidationSpecification;static TransformJobDefinition:typeof TransformJobDefinition;static DriftCheckModelDataQuality:typeof DriftCheckModelDataQuality;static FileSource:typeof FileSource;static MetricsSource:typeof MetricsSource;static ModelPackageStatusItem:typeof ModelPackageStatusItem;static AdditionalInferenceSpecificationDefinition:typeof AdditionalInferenceSpecificationDefinition;static SourceAlgorithmSpecification:typeof SourceAlgorithmSpecification;static ModelQuality:typeof ModelQuality;static S3DataSource:typeof S3DataSource;static ModelMetrics:typeof ModelMetrics;static SourceAlgorithm:typeof SourceAlgorithm;static InferenceSpecification:typeof InferenceSpecification;static MetadataProperties:typeof MetadataProperties;static DriftCheckExplainability:typeof DriftCheckExplainability;static TransformResources:typeof TransformResources;static ModelPackageContainerDefinition:typeof ModelPackageContainerDefinition;static ValidationProfile:typeof ValidationProfile;static Bias:typeof Bias;static DriftCheckModelQuality:typeof DriftCheckModelQuality;static DataSource:typeof DataSource;static TransformOutput:typeof TransformOutput;static ModelPackageStatusDetails:typeof ModelPackageStatusDetails;static DriftCheckBaselines:typeof DriftCheckBaselines;static ModelDataQuality:typeof ModelDataQuality;static TransformInput:typeof TransformInput;static DriftCheckBias:typeof DriftCheckBias;constructor(properties?:Properties);}export{ModelPackage as R};