import{ResourceBase,ResourceTag}from'../resource';import{Value,List}from'../dataTypes';export declare class CustomRequestHandling{InsertHeaders:List<CustomHTTPHeader>;constructor(properties:CustomRequestHandling);}export declare class ManagedRuleGroupStatement{Name:Value<string>;VendorName:Value<string>;Version?:Value<string>;ExcludedRules?:List<ExcludedRule>;ScopeDownStatement?:Statement;ManagedRuleGroupConfigs?:List<ManagedRuleGroupConfig>;constructor(properties:ManagedRuleGroupStatement);}export declare class FieldIdentifier{Identifier:Value<string>;constructor(properties:FieldIdentifier);}export declare class TextTransformation{Priority:Value<number>;Type:Value<string>;constructor(properties:TextTransformation);}export declare class AllowAction{CustomRequestHandling?:CustomRequestHandling;constructor(properties:AllowAction);}export declare class DefaultAction{Allow?:AllowAction;Block?:BlockAction;constructor(properties:DefaultAction);}export declare class XssMatchStatement{FieldToMatch:FieldToMatch;TextTransformations:List<TextTransformation>;constructor(properties:XssMatchStatement);}export declare class ByteMatchStatement{SearchString?:Value<string>;SearchStringBase64?:Value<string>;FieldToMatch:FieldToMatch;TextTransformations:List<TextTransformation>;PositionalConstraint:Value<string>;constructor(properties:ByteMatchStatement);}export declare class ForwardedIPConfiguration{HeaderName:Value<string>;FallbackBehavior:Value<string>;constructor(properties:ForwardedIPConfiguration);}export declare class OrStatement{Statements:List<Statement>;constructor(properties:OrStatement);}export declare class Label{Name:Value<string>;constructor(properties:Label);}export declare class CookieMatchPattern{All?:{[key:string]:any;};IncludedCookies?:List<Value<string>>;ExcludedCookies?:List<Value<string>>;constructor(properties:CookieMatchPattern);}export declare class CustomHTTPHeader{Name:Value<string>;Value:Value<string>;constructor(properties:CustomHTTPHeader);}export declare class RegexPatternSetReferenceStatement{Arn:Value<string>;FieldToMatch:FieldToMatch;TextTransformations:List<TextTransformation>;constructor(properties:RegexPatternSetReferenceStatement);}export declare class IPSetForwardedIPConfiguration{HeaderName:Value<string>;FallbackBehavior:Value<string>;Position:Value<string>;constructor(properties:IPSetForwardedIPConfiguration);}export declare class CustomResponseBody{ContentType:Value<string>;Content:Value<string>;constructor(properties:CustomResponseBody);}export declare class Statement{ByteMatchStatement?:ByteMatchStatement;SqliMatchStatement?:SqliMatchStatement;XssMatchStatement?:XssMatchStatement;SizeConstraintStatement?:SizeConstraintStatement;GeoMatchStatement?:GeoMatchStatement;RuleGroupReferenceStatement?:RuleGroupReferenceStatement;IPSetReferenceStatement?:IPSetReferenceStatement;RegexPatternSetReferenceStatement?:RegexPatternSetReferenceStatement;ManagedRuleGroupStatement?:ManagedRuleGroupStatement;RateBasedStatement?:RateBasedStatement;AndStatement?:AndStatement;OrStatement?:OrStatement;NotStatement?:NotStatement;LabelMatchStatement?:LabelMatchStatement;RegexMatchStatement?:RegexMatchStatement;constructor(properties:Statement);}export declare class ImmunityTimeProperty{ImmunityTime:Value<number>;constructor(properties:ImmunityTimeProperty);}export declare class BlockAction{CustomResponse?:CustomResponse;constructor(properties:BlockAction);}export declare class RuleGroupReferenceStatement{Arn:Value<string>;ExcludedRules?:List<ExcludedRule>;constructor(properties:RuleGroupReferenceStatement);}export declare class LabelMatchStatement{Scope:Value<string>;Key:Value<string>;constructor(properties:LabelMatchStatement);}export declare class JsonMatchPattern{All?:{[key:string]:any;};IncludedPaths?:List<Value<string>>;constructor(properties:JsonMatchPattern);}export declare class AndStatement{Statements:List<Statement>;constructor(properties:AndStatement);}export declare class CountAction{CustomRequestHandling?:CustomRequestHandling;constructor(properties:CountAction);}export declare class CaptchaConfig{ImmunityTimeProperty?:ImmunityTimeProperty;constructor(properties:CaptchaConfig);}export declare class SizeConstraintStatement{FieldToMatch:FieldToMatch;ComparisonOperator:Value<string>;Size:Value<number>;TextTransformations:List<TextTransformation>;constructor(properties:SizeConstraintStatement);}export declare class FieldToMatch{SingleHeader?:{[key:string]:any;};SingleQueryArgument?:{[key:string]:any;};AllQueryArguments?:{[key:string]:any;};UriPath?:{[key:string]:any;};QueryString?:{[key:string]:any;};Body?:Body;Method?:{[key:string]:any;};JsonBody?:JsonBody;Headers?:Headers;Cookies?:Cookies;constructor(properties:FieldToMatch);}export declare class SqliMatchStatement{FieldToMatch:FieldToMatch;TextTransformations:List<TextTransformation>;constructor(properties:SqliMatchStatement);}export declare class ManagedRuleGroupConfig{LoginPath?:Value<string>;PayloadType?:Value<string>;UsernameField?:FieldIdentifier;PasswordField?:FieldIdentifier;constructor(properties:ManagedRuleGroupConfig);}export declare class GeoMatchStatement{CountryCodes?:List<Value<string>>;ForwardedIPConfig?:ForwardedIPConfiguration;constructor(properties:GeoMatchStatement);}export declare class RuleAction{Allow?:AllowAction;Block?:BlockAction;Count?:CountAction;Captcha?:CaptchaAction;constructor(properties:RuleAction);}export declare class JsonBody{MatchPattern:JsonMatchPattern;MatchScope:Value<string>;InvalidFallbackBehavior?:Value<string>;OversizeHandling?:Value<string>;constructor(properties:JsonBody);}export declare class Body{OversizeHandling?:Value<string>;constructor(properties:Body);}export declare class NotStatement{Statement:Statement;constructor(properties:NotStatement);}export declare class OverrideAction{Count?:{[key:string]:any;};None?:{[key:string]:any;};constructor(properties:OverrideAction);}export declare class RegexMatchStatement{RegexString:Value<string>;FieldToMatch:FieldToMatch;TextTransformations:List<TextTransformation>;constructor(properties:RegexMatchStatement);}export declare class Headers{MatchPattern:HeaderMatchPattern;MatchScope:Value<string>;OversizeHandling:Value<string>;constructor(properties:Headers);}export declare class Rule{Name:Value<string>;Priority:Value<number>;Statement:Statement;Action?:RuleAction;OverrideAction?:OverrideAction;RuleLabels?:List<Label>;VisibilityConfig:VisibilityConfig;CaptchaConfig?:CaptchaConfig;constructor(properties:Rule);}export declare class CustomResponse{ResponseCode:Value<number>;CustomResponseBodyKey?:Value<string>;ResponseHeaders?:List<CustomHTTPHeader>;constructor(properties:CustomResponse);}export declare class RateBasedStatement{Limit:Value<number>;AggregateKeyType:Value<string>;ScopeDownStatement?:Statement;ForwardedIPConfig?:ForwardedIPConfiguration;constructor(properties:RateBasedStatement);}export declare class HeaderMatchPattern{All?:{[key:string]:any;};IncludedHeaders?:List<Value<string>>;ExcludedHeaders?:List<Value<string>>;constructor(properties:HeaderMatchPattern);}export declare class ExcludedRule{Name:Value<string>;constructor(properties:ExcludedRule);}export declare class VisibilityConfig{SampledRequestsEnabled:Value<boolean>;CloudWatchMetricsEnabled:Value<boolean>;MetricName:Value<string>;constructor(properties:VisibilityConfig);}export declare class IPSetReferenceStatement{Arn:Value<string>;IPSetForwardedIPConfig?:IPSetForwardedIPConfiguration;constructor(properties:IPSetReferenceStatement);}export declare class CaptchaAction{CustomRequestHandling?:CustomRequestHandling;constructor(properties:CaptchaAction);}export declare class Cookies{MatchPattern:CookieMatchPattern;MatchScope:Value<string>;OversizeHandling:Value<string>;constructor(properties:Cookies);}export interface Properties{DefaultAction:DefaultAction;Description?:Value<string>;Name?:Value<string>;Scope:Value<string>;Rules?:List<Rule>;VisibilityConfig:VisibilityConfig;Tags?:List<ResourceTag>;CustomResponseBodies?:{[key:string]:CustomResponseBody;};CaptchaConfig?:CaptchaConfig;}declare class WebACL extends ResourceBase<Properties>{static CustomRequestHandling:typeof CustomRequestHandling;static ManagedRuleGroupStatement:typeof ManagedRuleGroupStatement;static FieldIdentifier:typeof FieldIdentifier;static TextTransformation:typeof TextTransformation;static AllowAction:typeof AllowAction;static DefaultAction:typeof DefaultAction;static XssMatchStatement:typeof XssMatchStatement;static ByteMatchStatement:typeof ByteMatchStatement;static ForwardedIPConfiguration:typeof ForwardedIPConfiguration;static OrStatement:typeof OrStatement;static Label:typeof Label;static CookieMatchPattern:typeof CookieMatchPattern;static CustomHTTPHeader:typeof CustomHTTPHeader;static RegexPatternSetReferenceStatement:typeof RegexPatternSetReferenceStatement;static IPSetForwardedIPConfiguration:typeof IPSetForwardedIPConfiguration;static CustomResponseBody:typeof CustomResponseBody;static Statement:typeof Statement;static ImmunityTimeProperty:typeof ImmunityTimeProperty;static BlockAction:typeof BlockAction;static RuleGroupReferenceStatement:typeof RuleGroupReferenceStatement;static LabelMatchStatement:typeof LabelMatchStatement;static JsonMatchPattern:typeof JsonMatchPattern;static AndStatement:typeof AndStatement;static CountAction:typeof CountAction;static CaptchaConfig:typeof CaptchaConfig;static SizeConstraintStatement:typeof SizeConstraintStatement;static FieldToMatch:typeof FieldToMatch;static SqliMatchStatement:typeof SqliMatchStatement;static ManagedRuleGroupConfig:typeof ManagedRuleGroupConfig;static GeoMatchStatement:typeof GeoMatchStatement;static RuleAction:typeof RuleAction;static JsonBody:typeof JsonBody;static Body:typeof Body;static NotStatement:typeof NotStatement;static OverrideAction:typeof OverrideAction;static RegexMatchStatement:typeof RegexMatchStatement;static Headers:typeof Headers;static Rule:typeof Rule;static CustomResponse:typeof CustomResponse;static RateBasedStatement:typeof RateBasedStatement;static HeaderMatchPattern:typeof HeaderMatchPattern;static ExcludedRule:typeof ExcludedRule;static VisibilityConfig:typeof VisibilityConfig;static IPSetReferenceStatement:typeof IPSetReferenceStatement;static CaptchaAction:typeof CaptchaAction;static Cookies:typeof Cookies;constructor(properties:Properties);}export{WebACL as R};